<template>
  <AppAboutPage :breadcrumbs="$options.breadcrumbs">
    <template slot="content">
      <div class="aboutText">
        <h2 class="title">Контакты</h2>
        <p>
          Если есть вопросы, позвоните нам по телефону
          <flink
            class="link __no-wrap"
            :href="`tel:${trimPhoneNumber($config.contacts.info.phone)}`">
            {{ this.$config.contacts.info.phone }}
          </flink>
          (с 5:00 до 18:00 по МСК),<br>
          напишите на почту
          <flink
            class="link"
            target="_blank"
            href="mailto:info@gisauto.ru">info@gisauto.ru,
          </flink>
          или отправьте вопрос через форму обратной связи.
        </p>
      </div>

      <form
        v-if="!complete"
        class="supportForm"
        autocomplete="off"
        novalidate
        @submit.prevent="send">
        <div class="supportForm-item">
          <div class="supportForm-title">Укажите цель вашего обращения</div>
          <div
            class="supportForm-field"
            :class="{'-invalid': validation.hasError('form.department')}">
            <div class="input-message-error">{{ validation.firstError('form.department') }}</div>
            <AppSelect
              v-model="form.department"
              :options="$options.departments"
              :class="{'-invalid': validation.hasError('form.department')}"
              track-by="id"
              label="department"
              placeholder="Выберите отдел"/>
          </div>
          <div class="supportForm-field">
            <div
              class="input"
              :class="{'-invalid': validation.hasError('form.message')}">
              <div class="input-message-error">
                {{ validation.firstError('form.message') }}
              </div>
              <textarea
                v-model="form.message"
                class="input-field"
                placeholder="Ваш вопрос или сообщение *"
                cols="30"
                rows="10"/>
            </div>
          </div>
        </div>
        <div class="supportForm-item">
          <div class="supportForm-title">Укажите ваши контакты</div>
          <div
            class="supportForm-field"
            :class="{'-invalid': validation.hasError('form.name')}">
            <div class="input-message-error">{{ validation.firstError('form.city') }}</div>
            <AppCitySearch
              v-model="form.city"
              :composite="false"
              :classes="{'-invalid': validation.hasError('form.name')}"
              placeholder="Город *"/>
          </div>
          <div class="supportForm-field">
            <div
              class="input"
              :class="{'-invalid': validation.hasError('form.name')}">
              <div class="input-message-error">{{ validation.firstError('form.name') }}</div>
              <input
                v-model="form.name"
                class="input-field"
                type="text"
                placeholder="Имя *">
            </div>
          </div>
          <div
            class="supportForm-field"
            :class="{'-invalid': validation.hasError('form.phone')}">
            <div
              v-if="validation.hasError('form.phone')"
              class="input-message-error">
              {{ validation.firstError('form.phone') }}
            </div>
            <AppInputPhone
              v-model="form.phone"
              :classes="{ '-invalid': validation.hasError('form.phone') }"
              :composite="false"/>
          </div>
          <div class="supportForm-field">
            <div
              class="input"
              :class="{'-invalid': validation.hasError('form.email')}">
              <div class="input-message-error">
                {{ validation.firstError('form.email') }}
              </div>
              <input
                v-model="form.email"
                class="input-field"
                type="text"
                placeholder="E-mail *">
            </div>
          </div>
        </div>

        <div class="supportForm-item">
          <div class="supportForm-notes">
            Нажимая кнопку «Отправить сообщение», вы
            соглашаетесь на
            <flink
              target="_blank"
              domain="main"
              href="/about-us/agreement"
              class="link">обработку персональных
            </flink>
            данных
          </div>
        </div>
        <div class="supportForm-item">
          <AppButton type="submit">
            <template #button-item>Отправить сообщение</template>
          </AppButton>
        </div>
      </form>

      <div
        class="supportSuccess"
        v-if="complete">
        <div class="supportSuccess-item">
          <img
            svg-inline
            src="~/assets/svg/redesign/ok-big.svg">
          <div class="__medium">Сообщение отправлено. <br>
            Наши специалисты свяжутся с вами в течение рабочего дня.</div>
        </div>
        <div class="supportSuccess-item">
          <AppButton @click.native.prevent="reset">
            <template #button-item>Отправить еще одно сообщение</template>
          </AppButton>
        </div>
      </div>
    </template>
  </AppAboutPage>
</template>

<script>
import SimpleVueValidation from 'simple-vue-validator';
import AppAboutPage from '~/components/redesign/layout/app-about-page';
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/about-us/contacts';
import AppSelect from '~/components/redesign/app-select/app-select';
import AppCitySearch from '~/components/redesign/app-input/app-city-search';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import AppButton from '~/components/redesign/app-buttons/app-button';

// Helpers
import mapFilters from '~/assets/js/helpers/map-filters';
import Validator from '~/assets/js/validator';

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
  },
});

export default {
  name: 'AboutUsContacts',
  components: {
    AppButton,
    AppInputPhone,
    AppCitySearch,
    AppSelect,
    AppAboutPage,
  },
  mixins: [SeoMixin, SeoPageMixin],
  async asyncData({ store }) {
    const auth = store.state.user.auth;
    const form = {
      department: null,
      email: null,
      phone: null,
      name: null,
      city: null,
      message: '',
    };

    if (auth) {
      form.email = auth.chatRole !== 'guest' ? auth.username : '';
      form.phone = auth.userProfile && auth.userProfile.phone ? auth.userProfile.phone : '';
      form.name = auth.userProfile && auth.userProfile.firstName ? auth.userProfile.firstName : '';

      const city = {
        id: auth.userProfile && auth.userProfile.city ? auth.userProfile.city.id : 0,
        name: auth.userProfile && auth.userProfile.city ? auth.userProfile.city.name : '',
      };

      city.region = auth.userProfile && auth.userProfile.city && auth.userProfile.city.parent
        ? auth.userProfile.city.parent.name
        : '';

      form.city = city;
    }

    return {
      form,
    };
  },
  data() {
    return {
      complete: false,
    };
  },
  validators: {
    'form.department'(value) {
      return SimpleVueValidator.value(value).required();
    },
    'form.city'(value) {
      return SimpleVueValidator.value(value).required();
    },
    'form.name'(value) {
      return SimpleVueValidator.value(value).custom(() => !value && 'Укажите ваше имя');
    },
    'form.phone'(value) {
      return SimpleVueValidator.value(value).custom(() => {
        if (this.validation.isTouched('form.email') && this.form.email && this.validation.isPassed('form.email')) {
          return false;
        }
        if (!Validator.checkPhone(value)) {
          return 'Укажите корректный номер телефона или E-mail';
        }
        return false;
      });
    },
    'form.email'(value) {
      return SimpleVueValidator.value(value).custom(() => {
        if (this.validation.isTouched('form.phone') && this.form.phone && this.validation.isPassed('form.phone')) {
          return false;
        }
        if (!Validator.checkEmail(value)) {
          return 'Укажите корректный E-mail или номер телефона';
        }
        return false;
      });
    },
    'form.message'(value) {
      return SimpleVueValidator.value(value).custom(() => !value && 'Введите ваш вопрос или сообщение');
    },
  },
  created() {
    this.$options.departments = [
      { id: 1, department: 'Отдел продаж' },
      { id: 2, department: 'Тех поддержка' },
      { id: 3, department: 'Администрация' },
    ];
    this.$options.breadcrumbs = [
      {
        url: '/about-us',
        name: 'О проекте',
      },
      {
        url: '',
        name: 'Контакты',
      },
    ];
  },
  methods: {
    ...mapFilters(['trimPhoneNumber']),
    async send() {
      try {
        const isValid = await this.$validate();
        if (isValid) {
          const { type } = await this.$axios.$post('/_main/techSupport/createRequest', {
            name: this.form.name,
            receiver: this.form.department.id,
            phone: this.form.phone,
            email: this.form.email,
            city: this.form.city.id,
            message: this.form.message,
          });
          // TODO: Заменить на ENUM который попадет после MR с веткой Seller
          this.complete = type === 'success';
        }
      } catch (error) {
        console.error(error);
        const { data } = error.response;
        if (data.message) {
          // TODO: Какое окно будем показывать
          console.log(data.message);
        }
      }
    },
    reset() {
      this.form.message = '';
      this.form.department = null;
      this.validation.reset();
      this.complete = false;
    },
  },
};
</script>

<style lang="postcss">
  .supportSuccess {
    padding-top: 1.5rem;

    &-item {
      display: flex;
      align-items: center;
      font-size: 1.125rem;
      padding-bottom: 2.5rem;

      .svg {
        margin-right: 1.5rem;
        width: 3.25rem;
        height: auto;
      }

      .button {
        width: 21.875rem;
      }
    }

    @media screen and (max-width: 980px) {
      flex-direction: column;
      margin: 1rem -1.25rem -4rem;
      padding: 1.5rem 1.25rem 2rem;
      background-color: var(--bg-lightest);
      &-item {
        flex-direction: column;
        text-align: center;
        .svg {
          margin: 0 auto 1.5rem;
        }
        .button {
          width: 100%;
          line-height: 1.2;
        }
      }
    }
  }
  .supportForm {
    display: flex;
    flex-wrap: wrap;
    padding-top: 1.5rem;
    margin: 0 -1.25rem;

    &-title {
      font-size: 0.875rem;
      font-weight: var(--font-weight-medium);
    }

    &-item {
      display: block;
      padding: 1rem 1.25rem 0;
      width: 50%;
    }

    &-field {
      padding-top: 1rem;
      width: 100%;

      &.-invalid {
        & > .input-message-error {
          display: block;
        }
      }
    }

    &-notes {
      display: block;
      margin-left: auto;
      max-width: 18rem;
      font-size: 0.75rem;
      text-align: right;
    }

    textarea.input-field {
      height: 9.125rem;
      resize: none;
    }

    .button {
      width: 100%;
    }

    .input-message-error {
      padding-top: 0;
      margin-top: -1rem;
      line-height: 1rem;
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      margin: 0 -0.5rem;

      textarea.input-field {
        height: 11rem;
      }

      &-item {
        padding: 1rem 0.5rem 0;
      }
    }

    @media screen and (max-width: 980px) {
      flex-direction: column;
      margin: 1rem -1.25rem -4rem;
      padding: 1.5rem 1.25rem 2rem;
      background-color: var(--bg-lightest);

      &-item {
        padding: 1rem 0 0;
        width: 100%;
      }
      &-notes {
        margin-left: 0;
        text-align: left;
      }
    }

  }
</style>
